<?php

namespace Slovocast\Infrastructure\Database;

use React\Mysql\MysqlClient;
use Slovocast\Infrastructure\Api\Database\ConnectionPoolInterface;
use Slovocast\Infrastructure\Api\Database\PooledConnectionInterface;

class PooledConnection extends MysqlClient implements PooledConnectionInterface
{
    protected ConnectionPoolInterface $connectionPool;

    public function setConnectionPool(ConnectionPoolInterface $connectionPool): self
    {
        $this->connectionPool = $connectionPool;
        return $this;
    }

    public function release(): void
    {
        $this->connectionPool->releaseConnection($this);
    }
}
